#ifndef TEMP_HPP
#define TEMP_HPP

#include "util.hpp"
#include <vector>

namespace temp {
enum class TempType {
    INT,
    FLOAT,
    INT_PTR,
    FLOAT_PTR,
};

class Temp {
public:
    int num;
    TempType type;
    bool isReg() const;
};
Temp *newTemp(TempType type);
Temp *newNamedTemp(TempType type, int num);

using TempList = std::vector<Temp *>;

enum class OperandKind {
    TEMP,
    CONSTI,
    CONSTF,
};

class Operand {
public:
    OperandKind kind;
    union {
        Temp *temp;
        int consti;
        float constf;
    } u;
};
Operand *newTempOperand(Temp *temp);
Operand *newConstiOperand(int consti);
Operand *newConstfOperand(float constf);

using OperandList = std::vector<Operand>;

using Label = util::Symbol;
Label *newLabel();
Label *newLabelWithPrefix(const std::string &prefix);
Label *newNamedLabel(const std::string &name);
std::string *getLabelString(const Label *label);

using LabelList = std::vector<Label>;
} // namespace temp

#endif // TEMP_HPP