#ifndef UTIL_HPP
#define UTIL_HPP

#include <string>

namespace util {
template <class... T> std::string format(const char *fmt, const T &...t) {
    const auto len = snprintf(nullptr, 0, fmt, t...);
    std::string r;
    r.resize(static_cast<size_t>(len) + 1);
    snprintf(&r.front(), len + 1, fmt, t...); // Bad boy
    r.resize(static_cast<size_t>(len));

    return r;
}


class Symbol {
public:
    Symbol() = default;
    Symbol(const std::string &name) : name(name) {}
    std::string name;
    bool operator==(const Symbol &rhs) const;
};
Symbol *getSymbol(const std::string &name);

} // namespace util

#endif // UTIL_HPP