#include "temp.hpp"

#include "util.hpp"
#include <unordered_map>

namespace temp {
static std::unordered_map<int, Temp *> tempTable;
static int tempCounter = 100;

bool Temp::isReg() const { return num < 100; }

Temp *newTemp(TempType type) {
    Temp *temp = new Temp();
    temp->num = tempCounter++;
    temp->type = type;
    tempTable[temp->num] = temp;
    return temp;
}

Operand *newTempOperand(Temp *temp) {
    Operand *operand = new Operand();
    operand->kind = OperandKind::TEMP;
    operand->u.temp = temp;
    return operand;
}

Operand *newConstiOperand(int consti) {
    Operand *operand = new Operand();
    operand->kind = OperandKind::CONSTI;
    operand->u.consti = consti;
    return operand;
}

Operand *newConstfOperand(float constf) {
    Operand *operand = new Operand();
    operand->kind = OperandKind::CONSTF;
    operand->u.constf = constf;
    return operand;
}

static int labelCounter = 0;

Label *newLabel() { return util::getSymbol(util::format(".L%d", labelCounter++)); }

Label *newLabelWithPrefix(const std::string &prefix) {
    return util::getSymbol(util::format("%s%d", prefix.c_str(), labelCounter++));
}

Label *newNamedLabel(const std::string &name) { return util::getSymbol(name); }

std::string *getLabelString(const Label *label) { return &const_cast<Label *>(label)->name; }
} // namespace temp