#include "util.hpp"
#include <unordered_map>

namespace util {
static std::unordered_map<std::string, Symbol> symbolTable;

Symbol *getSymbol(const std::string &name) {
    if (symbolTable.find(name) == symbolTable.end()) {
        symbolTable[name] = Symbol(name);
    }

    return &symbolTable[name];
}

bool Symbol::operator==(const Symbol &rhs) const { return this->name == rhs.name; }
} // namespace util